/* WCETextAreaPeer.java
   Copyright (C) 2005 Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce;

import java.awt.Dimension;
import java.awt.TextArea;
import java.awt.peer.TextAreaPeer;

public class WCETextAreaPeer extends WCETextComponentPeer implements TextAreaPeer {
	WCETextAreaPeer(TextArea textArea) {
		super(textArea);
		setText(textArea.getText());
		setEditable(textArea.isEditable());
	}
	
	protected int createNative(int parentWindowHandle, int x, int y, int width, int height) {
		return createNativeTextArea(parentWindowHandle,
									x,
									y,
									width,
									height,
									((TextArea) getComponent()).getScrollbarVisibility());
	}

	protected native int createNativeTextArea(int parentWindowHandle, int x, int y, int width, int height, int scrollbarVisibility);

	public void insert(String text, int pos) {
		insertNative(getWindowHandle(), text, pos);
	}
	
	private native void insertNative(int windowHandle, String text, int pos);
	
	public void insertText(String text, int pos) {
		insert(text, pos);
	}

	public Dimension minimumSize(int rows, int cols) {
		return getMinimumSize(rows, cols);
	}
	
	public Dimension preferredSize(int rows, int cols) {
		return getPreferredSize(rows, cols);
	}
	
	public Dimension getMinimumSize(int rows, int cols) {
		return getPreferredSize(rows, cols);
	}
	
	public Dimension getPreferredSize(int rows, int cols) {
		return getNativePreferredSize(getWindowHandle(), rows, cols);
	}
	
	private native Dimension getNativePreferredSize(int windowHandle, int rows, int cols);
	
	
	public void replaceRange(String text, int start_pos, int end_pos) {
		replaceNativeRange(getWindowHandle(), text, start_pos, end_pos);
	}
	
	private native void replaceNativeRange(int windowHandle, String text, int startPos, int endPos);
	
	public void replaceText(String text, int start_pos, int end_pos) {
		replaceRange(text, start_pos, end_pos);
	}
}
